
!OrderedCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:44'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!Character methodsFor: '*splitjoin' stamp: 'onierstrasz 4/10/2009 22:51'!
join: aSequenceableCollection
	^ self asString join: aSequenceableCollection
! !

!SortedCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:57'!
join: aCollection 
	"Curiously addAllLast: does not trigger a reSort, so we must do it here."
	^ (super join: aCollection) reSort; yourself
! !

!String methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 20:21'!
join: aCollection 
	^ String
		streamContents: [:stream | aCollection
				do: [:each | stream nextPutAll: each asString] "NB: coerce elements to Strings"
				separatedBy: [stream nextPutAll: self]]! !

!BlockContext methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 20:12'!
split: aSequenceableCollection 
	| result position |
	result := OrderedCollection new.
	position := 1.
	aSequenceableCollection
		withIndexDo: [:element :idx |
			(self value: element)
				ifTrue: [result add: (aSequenceableCollection copyFrom: position to: idx - 1).
					position := idx + 1]].
	result add: (aSequenceableCollection copyFrom: position to: aSequenceableCollection size).
	^ result! !

!Object methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
appendTo: aCollection
	"double dispatch for join:"
	^ aCollection addLast: self! !

!Object methodsFor: '*splitjoin' stamp: 'onierstrasz 4/10/2009 22:50'!
join: aSequenceableCollection
	^ (Array with: self) join: aSequenceableCollection! !

!Object methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
joinTo: stream
	"double dispatch for join:"
	^ stream nextPut: self! !

!Object methodsFor: '*splitjoin' stamp: 'onierstrasz 4/10/2009 22:49'!
split: aSequenceableCollection
	^ (Array with: self) split: aSequenceableCollection! !

!BlockClosure methodsFor: '*splitjoin' stamp: 'stephane.ducasse 4/13/2009 22:03'!
split: aSequenceableCollection 
	| result position |
	result := OrderedCollection new.
	position := 1.
	aSequenceableCollection
		withIndexDo: [:element :idx |
			(self value: element)
				ifTrue: [result add: (aSequenceableCollection copyFrom: position to: idx - 1).
					position := idx + 1]].
	result add: (aSequenceableCollection copyFrom: position to: aSequenceableCollection size).
	^ result! !

!RxMatcher methodsFor: '*splitjoin' stamp: 'TestRunner 11/6/2009 14:00'!
split: aString
	| result lastPosition |
	result := OrderedCollection new.
	stream := aString readStream.
	lastPosition := stream position.
	[ self searchStream: stream ] whileTrue:
		[ result add: (aString copyFrom: lastPosition+1 to: (self subBeginning: 1) first).
		self assert: lastPosition < stream position description: 'Regex cannot match null string'.
		lastPosition := stream position ].
	result add: (aString copyFrom: lastPosition+1 to: aString size).
	^ result! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
appendTo: aCollection
	"double dispatch for join:"
	^ aCollection addAllLast: self! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 20:19'!
join: aCollection
	"NB: this implementation only works for Array, since WriteStreams only work for Arrays and Strings. (!!)
	Overridden in OrderedCollection and SortedCollection."
	^ self class
		streamContents: [:stream | aCollection
				do: [:each | each joinTo: stream]
				separatedBy: [stream nextPutAll: self]]! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
joinTo: stream
	"double dispatch for join:"
	^ stream nextPutAll: self! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/10/2009 22:53'!
joinUsing: joiner
	"joiner - character, string or sequenceable collection
	returns collection of the same collection class as 'joiner', or a String"
	^ joiner join: self! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/10/2009 22:54'!
joinUsing: joiner last: last 
	"#(1 2 3 4) joinUsing: ', ' last: 'and'. => '1, 2, 3 and 4"
	^ last join: (Array
				with: (joiner join: self allButLast)
				with: self last)! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 20:57'!
split: aSequencableCollection
	| result position oldPosition |
	result := OrderedCollection new.
	position := 1.
	oldPosition := position.
	position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	[ position > 0 ] whileTrue: [
		result add: (aSequencableCollection copyFrom: oldPosition to: position - 1).
		position := position + self size.
		oldPosition := position.
		position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	].
	result add: (aSequencableCollection copyFrom: oldPosition to: aSequencableCollection size).
	^ result

! !

!SequenceableCollection methodsFor: '*splitjoin' stamp: 'onierstrasz 4/12/2009 20:20'!
splitOn: splitter 
	"splitter - can be a subsequence, a Block or a Regex (String receiver only).
	Any other object used as a splitter is treated as an Array containing that object."
	^ splitter split: self! !
